unit Pakka;
{
  Pakka-komponentti:
  - Omaa yleisen pakan ominaisuudet
  - Huomaa erityisesti:
   * Anna_kortti-metodi palauttaa pyydetyn kortin ja samalla POISTAA
     sen pakasta
   * Pakkaan voi siirt kaikki toisen pakan kortit kyttmll
     Siirra-metodia.
   * Jos halutaan klikattava pakka ilman liskoodausta, niin plle voidaan
     laittaa TImage, johon ei laiteta mitn kuvaa.
     Itse pakan Enable asetetaan tllin
     eptodeksi ja TImagen klikkauksella tehdn mit tarvitsee.

  JakoPakka-komponentti:
   - sislt kaikki kortit jo syntyessn

  5.11.1997/ Tanja Partanen ja Niina Riikonen

  Muutoksia 8.11.1997/vl
   + pakan tapahtumat OnTake, OnEmpty, OnInsert, OnFull
   + MaxKortteja ( = hlytysraja pakan tyttymiselle )
   + Kortin Owneriin liittyvt asiat pois, kosa Ownewria ei nhtvsti
     voi muuttaa
   + Listty jakopakkaan metodi Uusi, jotta korttiluokan vaihtaminen olisi
     helpompaa.
   + jarjesta
  Muutoksia 8.11.1997/vl
   + ParentColor := true
   + Listtv kortti piilotetaan vain jos se menee keskelle pakkaa
  Muutoksia 17.1.1998/vl
   + SetPuoli metodiin listty  SetVisible jotta knt samalla
     pakan vastaamaan nykyist tilannetta
  Muutoksia 12.11.1999/mk ja lp
  + Lisaa_paikkaan-metodi jaettu kahteen osaan: lisaa_paikkaan ja aseta.
    Jos perittess halutaan asetella pakan kortit muuten kuin pllekkin
    pinoon, kirjoitetaan aseta-metodi uudestaan.
  Muutoksia 10.12.1999/mk ja lp
  + tee_tarkistukset kortin poistuessa jarjetsaa pakan taas kuntoon
  + sotke on sekoittamista varten oleva aliohjelma, jonka aikana ei
    laheteta eventteja poistamisesta eik lismisest
  + FDoEvent protected (jotta voi tarvittaessa kytt)
  Muutoksia 27.8.2001/vl
  + hiiren tapahtumat pakalta siirtyvt kortille, jotta korttia
    pakkaa voi "napsauttaa"
    => tarvittaessa override metodit PakkaClick jne...
  + Kelpaako ja SaakoOttaa siirretty jo pakkaan.
  Muutoksia 2.9.2001/vl
  + ehdollinen kntminen CLX/VCL (pit mritell vakio CLX jos
    halutaan CLX-kirjaston mukainen knns
}

interface

uses
{$ifdef CLX}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls,QStdCtrls,
{$else}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,StdCtrls,
{$endif}
  Kortti;

type
  TPakka = class;
  TPakkaChangeMeth = procedure (sender:TPakka;i:integer;k:TKortti) of object;

  TPakka = class(TPanel)
  private
    Fkortit: TList; // array of TKortti
    FPuoli : TNakyy; //Tm ominaisuus maaraa mitenpain pakka on.
    FMaxKortteja : integer;                                                // vl
    FOnInsert : TPakkaChangeMeth;                                          // vl
    FOnTake : TPakkaChangeMeth;                                            // vl
    FOnEmpty : TPakkaChangeMeth;                                           // vl
    FOnFull : TPakkaChangeMeth;
  protected
    FDoEvent : boolean;                                                    // vl
    procedure PakkaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);  virtual;
    procedure PakkaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);  virtual;
    procedure PakkaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);  virtual;
    procedure PakkaClick(Sender: TObject); virtual;
    procedure PakkaDblClick(Sender: TObject); virtual;
  public
    constructor Create(AOwner:TComponent);              override;
    destructor  Destroy;                                override;
    function  kortteja:integer;                         virtual;
    procedure lisaa_loppuun(kortti:TKortti);            virtual;
    procedure lisaa_paikkaan(i:integer;kortti:TKortti); virtual;
    procedure lisaa_kortti(kortti:TKortti);             virtual;
    function  anna_kortti_i(i:integer):TKortti;         virtual;
    function  anna_kortti:TKortti;                      virtual;
    function  anna(k:TKortti):TKortti;                  virtual;
    function  anna_arvo:integer;                        virtual;
    function  anna_arvo_i(i:integer):integer;           virtual;
    procedure siirra(p:TPakka);                         virtual;
    procedure sekoita;                                  virtual;
    procedure jarjesta;                                 virtual;           // vl
    procedure SetPuoli(p:TNakyy);                       virtual;
    procedure SetVisible;                               virtual;

    procedure aseta(i:integer; kortti:TKortti);         virtual;
    procedure tee_tarkistukset(k: TKortti; i: integer); virtual;    // vl&mk&lp
    procedure sotke;                                    virtual;    // vl&mk&lp
    function  Kelpaako(k:TKortti):boolean;              virtual;
    function  SaakoOttaa(k:TKortti):boolean;            virtual;

    property  kortit:TList read Fkortit;
  published
    property  Puoli:TNakyy read FPuoli write SetPuoli;
    property  MaxKortteja : integer read FMaxKortteja write FMaxKortteja default 52;
    property  OnInsert : TPakkaChangeMeth read FOnInsert write FOnInsert;
    property  OnEmpty  : TPakkaChangeMeth read FOnEmpty write FOnEmpty;
    property  OnFull : TPakkaChangeMeth read FOnFull write FOnFull;
    property  OnTake : TPakkaChangeMeth read FOnTake write FOnTake;
  end;

type
  TJakoPakka = class(TPakka)
  private
  protected
  public
    function  Uusi(i:integer; maa:TMaa):TKortti;        virtual;
    procedure lisaa_kortit;                             virtual;
    procedure lisaa_maa(maa:TMaa);                      virtual;
    constructor Create(AOwner:TComponent);              override;
  published
  end;

procedure Register;

implementation
uses
  Liikkuva;

constructor TPakka.Create(AOwner:TComponent);
// Jos mielii pakkaa, joka olisi JO suunnitteluaikana kuvapuoli ylspin
// konstruktori tytyy FPuolen osalta kirjoittaa uusiksi.
begin
  Inherited;
  Caption      := ' ';
  BevelOuter   := bvNone;
  ParentColor  := true;
  Fkortit      := TList.Create;
  FPuoli       := Selka;
  FMaxKortteja := 52;
  FOnEmpty     := nil;
  FOnTake      := nil;
  FOnInsert    := nil;
  FOnFull      := nil;
  FDoEvent     := true;
end;

destructor  TPakka.Destroy;
begin
  kortit.Clear;  // Turha
  kortit.Free;
  inherited;
end;

function  TPakka.kortteja:integer;
begin
  result := kortit.Count;
end;

procedure TPakka.lisaa_loppuun(kortti:TKortti);
begin
  lisaa_paikkaan(kortteja,kortti);
end;

procedure TPakka.lisaa_kortti(kortti:TKortti);
begin
  lisaa_paikkaan(0,kortti);
end;

procedure TPakka.aseta(i: integer; kortti: TKortti);
var apu:TKortti;
begin
  if ( i=0 ) then begin                 //listn pakan pllimmiseksi
    if ( kortteja > 0 ) then begin
      apu := kortit[0];
      apu.Nakyy := Piilossa;            //edellinen kortti piilotetaan
    end;
    kortti.Nakyy := FPuoli;
  end
  else kortti.Nakyy  := Piilossa;      //vain pllimminen kortti nkyviss,
                                       //muut piilossa
end;

procedure TPakka.PakkaClick(Sender: TObject);
begin
  if ( Assigned(OnClick) ) then OnClick(Sender);
end;

procedure TPakka.PakkaDblClick(Sender: TObject);
begin
  if ( Assigned(OnDblClick) ) then OnDblClick(Sender);
end;

procedure TPakka.PakkaMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ( Assigned(OnMouseDown) ) then OnMouseDown(Sender,Button,Shift,X,Y);
end;

procedure TPakka.PakkaMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ( Assigned(OnMouseUp) ) then OnMouseUp(Sender,Button,Shift,X,Y);
end;

procedure TPakka.PakkaMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if ( Assigned(OnMouseMove) ) then OnMouseMove(Sender,Shift,X,Y);
end;

procedure TPakka.lisaa_paikkaan(i:integer;kortti:TKortti);
begin
  if ( (i < 0) or (i > kortteja) ) then i := kortteja;
  if ( kortti = nil ) then exit;
  if ( kortteja = 0 ) then Show;
  kortti.Parent := self;
//  kortti.Owner  := self;
  aseta(i, kortti);
  kortit.insert(i,kortti);
  if ( Assigned(FOnInsert) and FDoEvent ) then FOnInsert(self,i,kortti);
  if ( kortteja >= MaxKortteja ) and ( Assigned(FOnFull) and FDoEvent ) then
    FOnFull(self,i,kortti);
  kortti.OnClick := PakkaClick;
  kortti.OnDblClick := PakkaDblClick;
  kortti.OnMouseDown := PakkaMouseDown;
  kortti.OnMouseUp := PakkaMouseUp;
  kortti.OnMouseMove := PakkaMouseMove;

{$ifdef CLX}
//  MouseCapture := false;  // Qt vaatii tmn jostakin syyst
{$else}
//  MouseCapture := false;  // Qt vaatii tmn jostakin syyst
{$endif}
end;

procedure TPakka.tee_tarkistukset(k:TKortti;i:integer);
begin
  if ( kortit.Count = 0 ) then //Hide
  else
    if ( i = 0 ) then TKortti(kortit.Items[0]).Nakyy := puoli;
end;

function  TPakka.anna_kortti_i(i:integer):TKortti;
var apu:TKortti;
begin
  if( kortit.Count = 0 )then begin
    result := nil; exit;
  end;
  if( (i < 0) or (i > kortteja-1) ) then i := kortteja - 1;
  SetCaptureControl(nil);
  apu :=kortit[i];  // kortit[i].OnClick := nil;
//  apu.Owner := NIL;
//  apu.Nakyy := Piilossa;
//  anna_kortti_i := apu;                                           // vl
  Result := apu;  // ei ihan sama kuin c:n return apu;
  apu.OnClick := nil;
  apu.OnDblClick := nil;
  apu.OnMouseDown := nil;
  apu.OnMouseUp := nil;
  apu.OnMouseMove := nil;
  kortit.Remove(apu);
  tee_tarkistukset(apu,i);

  if ( Assigned(FOnTake) and FDoEvent ) then FOnTake(self,0,Result);
  if ( Assigned(FOnEmpty) and FDoEvent and ( Kortteja = 0 ) ) then
    FOnEmpty(self,0,Result);
end;

function  TPakka.anna(k:TKortti):TKortti;
var i:integer;
begin
  Result := nil;
  for i:=0 to kortteja-1 do
    if kortit.Items[i] = k then begin
      Result := anna_kortti_i(i);
      Exit;
    end;
end;


function  TPakka.anna_kortti:TKortti;
begin
  result := anna_kortti_i(0); // Annetaan siis pakan ensimminen kortti.
end;

function  TPakka.anna_arvo:integer;
begin
  result := anna_arvo_i(0);
end;

function  TPakka.anna_arvo_i(i:integer):integer;
var apu:TKortti;
begin
  if(kortit.Count = 0) then begin result := 0; exit; end;
  if( (i < 0) or (i > kortteja-1) ) then i := kortteja-1;
  apu := kortit.Items[i];
  result := apu.Arvo;
end;

procedure TPakka.siirra(p:TPakka);
begin
  if( p = self ) then exit;
  while (p.kortteja > 0) do
    lisaa_kortti(p.anna_kortti);
end;

procedure TPakka.sotke;
var i:integer;
begin
  for i := kortit.Count downto 1 do
    lisaa_loppuun(anna_kortti_i(random(i)));
end;

procedure TPakka.sekoita;
begin
  FDoEvent := false;
  sotke;
  FDoEvent := true;
end;

procedure TPakka.SetPuoli(p:TNakyy);
begin
  FPuoli := p;
  SetVisible;
end;

function compare(item1,item2:Pointer) : integer;
var k1,k2:TKortti;
begin
  k1 := item1;
  k2 := item2;
  Result := k1.SortValue - k2.SortValue;
end;

procedure TPakka.SetVisible;
var i:integer; k:TKortti;
begin
  for i:=0 to Kortit.Count-1 do begin
    k := Kortit[i];
    if ( i = 0 ) then k.Nakyy := Puoli
                 else k.Nakyy := Piilossa;
  end;
end;

procedure TPakka.jarjesta;
begin
  Fkortit.Sort(compare);
  SetVisible;
end;

function TPakka.Kelpaako(k:TKortti):boolean;
begin
  Result := kortteja < MaxKortteja;
end;

function TPakka.SaakoOttaa(k:TKortti):boolean;
begin
  Result := true;
end;

//---------------------------------------------------------------------
// Jakopakan omat metodit:

constructor TJakoPakka.Create(AOwner:TComponent);
begin
  inherited;
  lisaa_kortit;
end;

function TJakoPakka.Uusi(i:integer; maa:TMaa) : TKortti;
begin
  Result := TPeliKortti.Create3(self,i,maa);
end;

procedure TJakoPakka.lisaa_maa(maa:TMaa);
var i:integer;
var apu:TKortti;
begin
  for i:= 1 to 13 do begin
    apu := uusi(i,maa);
    lisaa_kortti(apu);
  end;
end;

procedure TJakoPakka.lisaa_kortit;
var maa:TMaa;
begin
//  for maa:=Ruutu to Ruutu do lisaa_maa(maa);
  for maa:=Ruutu to Pata do lisaa_maa(maa);
end;

procedure Register;
begin
  RegisterComponents('GKO', [TPakka,TJakoPakka]);
end;


end.
