unit Raahausp;
{
  Raahauspakka-komponentti:
  - Pakka, josta voidaan raahata kortteja

  Tekij:  Vesa Lappalainen
  Milloin: 16.1.1998

  Muutoksia
    +
}

interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QExtCtrls, QStdCtrls,
{$else}
  Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
{$endif}
  Kortti,Pakka,APakka;

type
  TRaahausPakka = class(TAPakka)
  private
    procedure DragArrive(o,w:TControl;data:integer);
  protected
  public
    constructor Create(AOwner:TComponent);        override;
    destructor  Destroy;                          override;
  published
    procedure PakkaMouseDown(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer); override;
end;

procedure Register;

implementation
uses raahattava;


constructor TRaahausPakka.Create(AOwner:TComponent);
begin
  Inherited;
  Height   := 100;
  Width    := 73;
end;

destructor  TRaahausPakka.Destroy;
begin
  inherited;
end;


procedure TRaahausPakka.DragArrive(o,w:TControl;data:integer);
var p:TRaahausPakka; k:TKortti;
begin
  if not ( o is TKortti ) then exit;
  k := ( o as TKortti );
  p := nil;
  if ( w is TKortti ) and ( w.Parent is TRaahausPakka )  then p := w.Parent as TRaahausPakka;
  if ( w is TRaahausPakka ) then p := ( w as TRaahausPakka );
  if ( p = nil ) then p := self;
  if ( not p.Kelpaako(k) ) then p := self;
  p.Puoli := k.Nakyy;
  k.left := 0; k.top := 0;
  p.lisaa_kortti(k);
end;


procedure TRaahausPakka.PakkaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var k:TKortti;
begin
  inherited;
  if ( Button <> mbLeft ) then exit;
  if not ( Sender is TKortti ) then exit;
  k := Sender as TKortti;
  if ( not SaakoOttaa(k) ) then exit;
  RaahaaXY(anna(k),x,y,DragArrive,0);
end;



procedure Register;
begin
  RegisterComponents('GKO', [TRaahausPakka]);
end;

end.
