unit SaantoP;
{
   Pakka johon voidaan antaa sntj raahattavan kortin hyvksymiselle:

   Author:  Vesa Lappalainen
   Date:    17.1.1998
   Changes:

   Snnt
      int eka;         - Jos pakka tyhj, mink kortin voi jtt
      int ero;         - Luku, joka listn pllimmisen olevaan, ett
                         saadaan seuraavan sopivan kortin arvo
      int lopetus;     - Pakkaan viimeiseksi sopiva kortti
      int jatko;       - Viimeisen plle kyv kortti

}

interface

uses
{$ifdef CLX}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls,Kortti,Pakka,APakka,Raahausp;
{$else}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Kortti,Pakka,APakka,Raahausp;
{$endif}

type
  TSaannot = class(TPersistent)
  private
    FEka       : integer;
    FEro       : integer;
    FLopetus   : integer;
    FJatko     : integer;
  published
    property Eka       : integer read FEka     write FEka;
    property Ero       : integer read FEro     write FEro;
    property Lopetus   : integer read FLopetus write FLopetus;
    property Jatko     : integer read FJatko   write FJatko;
  end;

  TSaantoPakka = class(TRaahausPakka)
    FSaannot : TSaannot;
  public
    constructor Create(AOwner:TComponent);     override;
    destructor  Destroy;                       override;
    function    Kelpaako(k:TKortti):boolean;   override;
  published
    property Saannot : TSaannot read FSaannot write FSaannot;
  end;

const spMikaVaan = -20;
      spEiMikaan = -30;

procedure Register;

implementation

constructor TSaantoPakka.Create(AOwner:TComponent);
begin
  FSaannot := TSaannot.Create;
  inherited;
end;

destructor  TSaantoPakka.Destroy;
begin
  FSaannot.Free;
  inherited;
end;

function  TSaantoPakka.Kelpaako(k:TKortti):boolean;
begin
  Result := false;
  if ( Kortteja >= MaxKortteja ) then exit;
  Result := true;
  if ( Kortteja = 0 ) then begin                      // Jos tyhj pakka
    if ( Saannot.Eka = spMikaVaan ) then exit;        // Ja mik vaan ekaksi, OK
    Result := k.Arvo = Saannot.Eka;                   // Muuten Eka suhde kortin
    Exit;                                             // arvoon ratkaisee
  end;

  if Saannot.Ero = spMikaVaan then exit;              // On kortteja joten OK
  Result := false;
  if Saannot.Ero = spEiMikaan then exit;              // Ei saa laittaa muita!
  if ( anna_arvo = Saannot.Lopetus ) then begin       // Jos pllim.on lopetus
    if ( k.Arvo <> Saannot.Jatko ) then exit;         // Niin ei kelpaa
    Result := true;                                   // Jollei ole jatko-kortti
    Exit;
  end;
  if ( k.Arvo - anna_arvo <> Saannot.Ero ) then exit; // Jos vr ero, niin ei
  Result := true;
end;

procedure Register;
begin
  RegisterComponents('GKO', [TSaantoPakka]);
end;

end.
